/*
 * lomb_scargel-test.c
 *
 *  Created on: Jul 31, 2009
 *      Author: agabasch
 */


/*-----------------------------------------------------------------------------
                                   Includes
 -----------------------------------------------------------------------------*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <math.h>
#include "cpl.h"
#include "cpl_test.h"
#include "lomb_scargel.h"


/*-----------------------------------------------------------------------------
                                   Defines
 -----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                        Private function prototypes
 -----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                                  Main
 -----------------------------------------------------------------------------*/
int main(void)
{
	cpl_array             * frequency_sinus=NULL;
	cpl_array             * fringe_sinus=NULL;
	int                     lomb_maxpos=0;
	int 					i=0;
	double                  lomb_maxfreq=0;
	cpl_array            ** lomb_out=NULL;


	cpl_test_init(PACKAGE_BUGREPORT, CPL_MSG_WARNING);
	/* Insert tests below */


	frequency_sinus =cpl_array_new(100, CPL_TYPE_DOUBLE);
	fringe_sinus =cpl_array_new(100, CPL_TYPE_DOUBLE);

	for(i=0;i<100;i++){
		cpl_array_set(frequency_sinus,i,i);
		cpl_array_set(fringe_sinus,i,sin(i));
	}
	lomb_maxpos=0;
	lomb_maxfreq=0.;


	lomb_out=cpl_malloc(2 * sizeof(cpl_array *));
	lomb(0,0.5,10000,frequency_sinus,fringe_sinus,lomb_out);

	cpl_array_get_maxpos (lomb_out[1], &lomb_maxpos);

	lomb_maxfreq=cpl_array_get_double(lomb_out[0],lomb_maxpos,NULL);



	cpl_msg_info(cpl_func,"Maximum Power-Peak at frequency: %g",
			lomb_maxfreq);

	cpl_test_abs( lomb_maxfreq, 0.1591, 3.5*DBL_EPSILON );

	/*       for(i=0;i<cpl_array_get_size(lomb_out[0]);i++){ */
	/*          cpl_msg_info(cpl_func,"index: %d frequency: %g  POWER: %g",i, */
	/*                       cpl_array_get_double(lomb_out[0],i,NULL), */
	/*                       cpl_array_get_double(lomb_out[1],i,NULL)); */

	/*       } */
	      cpl_array_delete(frequency_sinus);
	      cpl_array_delete(fringe_sinus);
	      cpl_array_delete(lomb_out[0]);
	      cpl_array_delete(lomb_out[1]);
	      cpl_free(lomb_out);
return cpl_test_end(0);
}
